unit ComInImport;

interface

uses Objects, TciGlobl, CommType;

var
  BeginCommIni      : function(const vIniFileName: FNameStr) : boolean;
  EndCommIni        : procedure;
  ReadChannelCfg    : function(var ChanInit : TChannelInit; Number : byte) : boolean;
  InitGetObjectCfg  : procedure;
  ReadObjectCfg     : function(var ObjInit : TObjectCfg) : boolean;
  ReadMainCfg       : function(var MainInit : TMainCfg) : boolean;

function InitCommIni : boolean;
procedure DoneCommIni;

implementation

uses WinApi;

const Handle : THandle = 0;

function InitCommIni : boolean;
  function GetProcedure(var Proc : pointer; const Name : pchar) : boolean;
    begin
      Proc := GetProcAddress(Handle, Name);
      GetProcedure := Proc <> nil;
    end;
  begin
    InitCommIni := false;
    Handle := LoadLibrary('COMINEXP.DLL');
    if (Handle >= 32) and
      GetProcedure(@BeginCommIni, 'BEGINCOMMINI') and
      GetProcedure(@EndCommIni, 'ENDCOMMINI') and
      GetProcedure(@ReadChannelCfg, 'READCHANNELCFG') and
      GetProcedure(@InitGetObjectCfg, 'INITGETOBJECTCFG') and
      GetProcedure(@ReadObjectCfg, 'READOBJECTCFG') and
      GetProcedure(@ReadMainCfg, 'READMAINCFG')
      then InitCommIni := true
    else DoneCommIni;
  end;

procedure DoneCommIni;
  begin
    if Handle >= 32 then
      begin
        EndCommIni;
        FreeLibrary(Handle);
        Handle := 0;
      end;
  end;

end.
