unit IniImport;

interface

uses Objects;

  function OpenIniFile(InFile : FNameStr) : boolean;
  procedure CloseIniFile;
  function GetIniError : integer;
  function EndIniFile : boolean;
  procedure SetIncludePath(P : FNameStr);
  function SearchSection(const SecName : string) : boolean;
  function SearchKey(const Key : string) : boolean;
  function GetKey(var Key : string) : boolean;
  procedure InitGetSection;
  function GetSection(var SecName : string) : boolean;
  function GetInteger(Min, Max, Default : longint) : longint;
  function GetFloat(Min, Max, Default : extended) : extended;
  function GetStatementNumber(const S : string; Default : integer) : integer;
  function GetString(Default : string) : string;
  function GetQuoteString(Default : string) : string;
  function GetBoolean(Default : boolean) : boolean;
  function GetLine : string;
  procedure Blanks;
  function ReadWord : string;
  function ReadString(LD, RD : char) : string;
  function ReadChar : char;
  function ReadNumeric : string;
  function ReadStr : string;
  function CheckStatement(const S,D : string) : byte;
  function GetStatement(const D : string; I : byte) : string;
  function NextChar : char;
  function ReadWordDelim(const Delims : TCharset) : string;
  function ReadPhrase : string;

implementation

  function OpenIniFile(InFile : FNameStr) : boolean;
    external 'INIEXPO' index 1;
  procedure CloseIniFile;
    external 'INIEXPO' index 2;
  function GetIniError : integer;
    external 'INIEXPO' index 3;
  procedure SetIncludePath(P : FNameStr);
    external 'INIEXPO' index 4;
  function EndIniFile : boolean;
    external 'INIEXPO' index 5;
  function SearchSection(const SecName : string) : boolean;
    external 'INIEXPO' index 10;
  function SearchKey(const Key : string) : boolean;
    external 'INIEXPO' index 11;
  function GetKey(var Key : string) : boolean;
    external 'INIEXPO' index 12;
  procedure InitGetSection;
    external 'INIEXPO' index 13;
  function GetSection(var SecName : string) : boolean;
    external 'INIEXPO' index 14;
  function GetInteger(Min, Max, Default : longint) : longint;
    external 'INIEXPO' index 20;
  function GetFloat(Min, Max, Default : extended) : extended;
    external 'INIEXPO' index 21;
  function GetStatementNumber(const S : string; Default : integer) : integer;
    external 'INIEXPO' index 22;
  function GetString(Default : string) : string;
    external 'INIEXPO' index 23;
  function GetQuoteString(Default : string) : string;
    external 'INIEXPO' index 24;
  function GetBoolean(Default : boolean) : boolean;
    external 'INIEXPO' index 25;
  function GetLine : string;
    external 'INIEXPO' index 26;
  procedure Blanks;
    external 'INIEXPO' index 30;
  function ReadWord : string;
    external 'INIEXPO' index 31;
  function ReadString(LD, RD : char) : string;
    external 'INIEXPO' index 32;
  function ReadChar : char;
    external 'INIEXPO' index 33;
  function ReadNumeric : string;
    external 'INIEXPO' index 34;
  function ReadStr : string;
    external 'INIEXPO' index 35;
  function CheckStatement(const S,D : string) : byte;
    external 'INIEXPO' index 36;
  function GetStatement(const D : string; I : byte) : string;
    external 'INIEXPO' index 37;
  function NextChar : char;
    external 'INIEXPO' index 38;
  function ReadWordDelim(const Delims : TCharset) : string;
    external 'INIEXPO' index 39;
  function ReadPhrase : string;
    external 'INIEXPO' index 40;

end.
