{} Unit ObjUtil {};

(**)INTERFACE(**)

uses Objects, Inlines;

type

  {   ப }
  PLineCollection = ^TLineCollection;
  TLineCollection = object(TCollection)
    function GetItem(var S: TStream): pointer; virtual;
    procedure PutItem(var S: TStream; Item: pointer); virtual;
    procedure FreeItem(P : pointer); virtual;
  end;

  {  ᥩ 䨪஢  }
  PRecordCollection = ^TRecordCollection;
  TRecordCollection = object(TCollection)
    RecSize : word;
    constructor Init(aLimit, aDelta : integer; aSize : word);
    constructor Load(var S : TStream);
    procedure Store(var S : TStream);
    function GetItem(var S: TStream): pointer; virtual;
    procedure PutItem(var S: TStream; Item: pointer); virtual;
    procedure FreeItem(Item: pointer); virtual;
  end;

  {  ᥩ ⨯ 㪠⥫+ப ६ .            }
  {  ࠡ   ப 樥: 㭪 At 頥    }
  { PString. ⮤ Insert   뢠.  ࠭  ⮪. }
  PAddressCollection = ^TAddressCollection;
  TAddressCollection = object(TCollection)
    procedure FreeItem(P : pointer); virtual;
    procedure InsertRec(P : pointer; const S : string);
    function GetAddress(Num : word) : pointer;
  end;

  {  ⮢   4 . ࠭    㪠⥫. }
  { 㭪 At 頥 祭  }
  { ( DX 襥,  AX 襥 ᫮).     }
  {  ⮤ Insert 室 ⠢ 祭  . }
  PFourByteCollection = ^TFourByteCollection;
  TFourByteCollection = object(TCollection)
    constructor Load(var S : TStream);
    procedure Store(var S : TStream);
    procedure FreeItem(Item: pointer); virtual;
    procedure Pack;
    destructor Done; virtual;
  end;

  { ஢  ப  ᥩ 䨪஢ , }
  { 稢 ப. 㭪 At 頥 PString. }
  { 㭪 AtRec 頥 㪠⥫  . }
  {  ⠢ ᯮ InsertRec,  ⭮  AtInsertRec. }
  PRSCollection = ^TRSCollection;
  TRSCollection = object(TStringCollection)
    RecSize : word; {     ப }
    constructor Init(aLimit, aDelta : integer; aSize : word);
    constructor Load(var S : TStream);
    procedure Store(var S : TStream);
    function GetItem(var S: TStream): pointer; virtual;
    procedure PutItem(var S: TStream; Item: pointer); virtual;
    procedure FreeItem(Item: pointer); virtual;
    procedure InsertRec(var Rec; const S : string);
    procedure AtInsertRec(var Rec; const S : string; Index : integer);
    function GetRec(Item : pointer) : pointer;
    function AtRec(Index : integer) : pointer;
    function FirstThatRec(Test : pointer) : pointer;
  end;

  {  ᥩ 䨪஢ , }
  { 稢 ப. 㭪 At 頥 PString. }
  { 㭪 AtRec 頥 㪠⥫  . }
  {  ⠢ ᯮ InsertRec,  ⭮  AtInsertRec. }
  PRLCollection = ^TRLCollection;
  TRLCollection = object(TLineCollection)
    RecSize : word; {     ப }
    constructor Init(aLimit, aDelta : integer; aSize : word);
    constructor Load(var S : TStream);
    procedure Store(var S : TStream);
    function GetItem(var S: TStream): pointer; virtual;
    procedure PutItem(var S: TStream; Item: pointer); virtual;
    procedure FreeItem(Item: pointer); virtual;
    procedure InsertRec(var Rec; const S : string);
    procedure AtInsertRec(var Rec; const S : string; Index : integer);
    function GetRec(Item : pointer) : pointer;
    function AtRec(Index : integer) : pointer;
    function FirstThatRec(Test : pointer) : pointer;
  end;

  { ஢  ᥫ ⨯ longint. ࠭    㪠⥫. }
  { 㭪 At 頥 祭  }
  { ( DX 襥,  AX 襥 ᫮).     }
  {  ⮤ Insert  Search 室 ⠢ 祭  . }
  PSortedNumCollection = ^TSortedNumCollection;
  TSortedNumCollection = object(TSortedCollection)
    constructor Load(var S : TStream);
    procedure Store(var S : TStream);
    function Compare(Key1, Key2: Pointer): Integer; virtual;
    procedure FreeItem(Item: pointer); virtual;
    procedure Pack;
    destructor Done; virtual;
  end;

  { ꥪ  ࠡ  ⥪⮢ 䠩 १ ⮪. }
  {   ⥭ ப. }
  PTextFile = ^TTextFile;
  TTextFile = object(TObject)
    Stream : PStream;
    constructor Init(S : PStream);
    procedure ReadLine(var S : string);
    procedure WriteLine(S : string);
    function ReadStr : PString;
    procedure Reset;
    destructor Done; virtual;
  end;

  { ⮩ ꥪ  ࠡ  誠  }
  PBuffer = ^TBuffer;
  TBuffer = object
    Bag : pointer;
    BufSize,
    DataSize,
    Position : word;
    procedure Init(P : pointer; Size : word);
    procedure Create(Size : word);
    procedure Reset;
    function Seek(P : word) : boolean;
    function Read(var Buf; Size : word) : boolean;
    function Write(var Buf; Size : word) : boolean;
    function ReadAt(var Buf; Size,Pos : word) : boolean;
    function WriteAt(var Buf; Size,Pos : word) : boolean;
    function PutBit(Number : word; Value : boolean) : boolean;
    function GetBit(Number : word; var Value : boolean) : boolean;
    function GetPtr : pointer;
    procedure Free;
  end;

{ ஢ 樨   At. 頥  ,
  襣  Action 祭 True  -1  ⨦  ᯨ᪠.}
function ScanAt(P : PCollection; At : integer; Action : pointer) : integer;

procedure RegisterObjUtils;

(**)IMPLEMENTATION(**)


{*** TLineCollection ***}

procedure TLineCollection.FreeItem(P : pointer);
  begin
    if P <> nil then DisposeStr(P);
  end;

function TLineCollection.GetItem(var S: TStream): pointer;
  begin
    GetItem := S.ReadStr;
  end;

procedure TLineCollection.PutItem(var S: TStream; Item: pointer);
  begin
    S.WriteStr(PString(Item));
  end;


{*** TRecordCollection ***}

constructor TRecordCollection.Init(aLimit, aDelta : integer; aSize : word);
  begin
    inherited Init(aLimit, aDelta);
    RecSize := aSize;
  end;

constructor TRecordCollection.Load(var S : TStream);
  begin
    S.Read(RecSize, SizeOf(RecSize));
    inherited Load(S);
  end;

procedure TRecordCollection.Store(var S : TStream);
  begin
    S.Write(RecSize, SizeOf(RecSize));
    inherited Store(S);
  end;

function TRecordCollection.GetItem(var S: TStream): pointer;
  var Item : pointer;
  begin
    GetMem(Item, RecSize);
    S.Read(Item^, RecSize);
    GetItem := Item;
  end;

procedure TRecordCollection.PutItem(var S: TStream; Item: pointer);
  begin
    S.Write(Item^, RecSize);
  end;

procedure TRecordCollection.FreeItem(Item: pointer);
  begin
    FreeMem(Item, RecSize);
  end;


{*** TAddressCollection ***}

procedure TAddressCollection.FreeItem(P : pointer);
  begin
    if P <> nil then
      FreeMem( Ptr(PtrRec(P).Seg, PtrRec(P).Ofs - 4), length(PString(P)^) + 5 );
  end;

procedure TAddressCollection.InsertRec(P : pointer; const S : string);
  var PT : ^pointer;
  begin
    PT := pointer( NewStr('   ' + chr(length(S)) + S) );
    PT^ := P;
    inc( PtrRec(PT).Ofs, 4 );
    Insert(PT);
  end;

function TAddressCollection.GetAddress(Num : word) : pointer;
  var PT : ^pointer;
  begin
    PT := At(Num);
    dec(PtrRec(PT).Ofs, 4);
    GetAddress := PT^;
  end;


{*** TRSCollection ***}

constructor TRSCollection.Init(aLimit, aDelta : integer; aSize : word);
  begin
    inherited Init(aLimit, aDelta);
    RecSize := aSize;
  end;

constructor TRSCollection.Load(var S : TStream);
  begin
    S.Read(RecSize, SizeOf(RecSize));
    inherited Load(S);
  end;

procedure TRSCollection.Store(var S : TStream);
  begin
    S.Write(RecSize, SizeOf(RecSize));
    inherited Store(S);
  end;

function TRSCollection.GetItem(var S: TStream): pointer;
  var Size : word;
      P : pointer;
  begin
    S.Read(Size, 2);
    if Size = 0 then GetItem := nil
    else
      begin
        GetMem(P, Size);
        S.Read(P^, Size);
        GetItem := ptr(ptrrec(P).Seg, ptrrec(P).Ofs+RecSize);
      end;
  end;

procedure TRSCollection.PutItem(var S: TStream; Item: pointer);
  var Size : word;
  begin
    if Item = nil then Size := 0
    else Size := length(PString(Item)^) + RecSize + 1;
    S.Write(Size, 2); if Size = 0 then exit;
    S.Write(ptr(ptrrec(Item).Seg, ptrrec(Item).Ofs - RecSize)^, Size);
  end;

procedure TRSCollection.FreeItem(Item: pointer);
  begin
    if Item <> nil then
      FreeMem(ptr(ptrrec(Item).Seg, ptrrec(Item).Ofs - RecSize),
              length(PString(Item)^) + RecSize + 1);
  end;

procedure TRSCollection.InsertRec(var Rec; const S : string);
  var P : pointer;
  begin
    GetMem(P, RecSize + length(S) + 1);
    move(Rec, P^, RecSize);
    inc(ptrrec(P).Ofs, RecSize);
    move(S, P^, length(S) + 1);
    Insert(P);
  end;

procedure TRSCollection.AtInsertRec(var Rec; const S : string; Index : integer);
  var P : pointer;
  begin
    GetMem(P, RecSize + length(S) + 1);
    move(Rec, P^, RecSize);
    inc(ptrrec(P).Ofs, RecSize);
    move(S, P^, length(S) + 1);
    AtInsert(Index, P);
  end;

function TRSCollection.AtRec(Index : integer) : pointer;
  begin
    AtRec := GetRec(At(Index));
  end;

function TRSCollection.GetRec(Item : pointer) : pointer;
  begin
    if Item <> nil then dec(ptrrec(Item).Ofs, RecSize);
    GetRec := Item;
  end;

function TRSCollection.FirstThatRec(Test : pointer) : pointer;
  begin
    FirstThatRec := GetRec(FirstThat(Test));
  end;


{*** TRLCollection ***}

constructor TRLCollection.Init(aLimit, aDelta : integer; aSize : word);
  begin
    inherited Init(aLimit, aDelta);
    RecSize := aSize;
  end;

constructor TRLCollection.Load(var S : TStream);
  begin
    S.Read(RecSize, SizeOf(RecSize));
    inherited Load(S);
  end;

procedure TRLCollection.Store(var S : TStream);
  begin
    S.Write(RecSize, SizeOf(RecSize));
    inherited Store(S);
  end;

function TRLCollection.GetItem(var S: TStream): pointer;
  var Size : word;
      P : pointer;
  begin
    S.Read(Size, 2);
    if Size = 0 then GetItem := nil
    else
      begin
        GetMem(P, Size);
        S.Read(P^, Size);
        GetItem := ptr(ptrrec(P).Seg, ptrrec(P).Ofs+RecSize);
      end;
  end;

procedure TRLCollection.PutItem(var S: TStream; Item: pointer);
  var Size : word;
  begin
    if Item = nil then Size := 0
    else Size := length(PString(Item)^) + RecSize + 1;
    S.Write(Size, 2); if Size = 0 then exit;
    S.Write(ptr(ptrrec(Item).Seg, ptrrec(Item).Ofs - RecSize)^, Size);
  end;

procedure TRLCollection.FreeItem(Item: pointer);
  begin
    if Item <> nil then
      FreeMem(ptr(ptrrec(Item).Seg, ptrrec(Item).Ofs - RecSize),
              length(PString(Item)^) + RecSize + 1);
  end;

procedure TRLCollection.InsertRec(var Rec; const S : string);
  var P : pointer;
  begin
    GetMem(P, RecSize + length(S) + 1);
    move(Rec, P^, RecSize);
    inc(ptrrec(P).Ofs, RecSize);
    move(S, P^, length(S) + 1);
    Insert(P);
  end;

procedure TRLCollection.AtInsertRec(var Rec; const S : string; Index : integer);
  var P : pointer;
  begin
    GetMem(P, RecSize + length(S) + 1);
    move(Rec, P^, RecSize);
    inc(ptrrec(P).Ofs, RecSize);
    move(S, P^, length(S) + 1);
    AtInsert(Index, P);
  end;

function TRLCollection.AtRec(Index : integer) : pointer;
  begin
    AtRec := GetRec(At(Index));
  end;

function TRLCollection.GetRec(Item : pointer) : pointer;
  begin
    if Item <> nil then dec(ptrrec(Item).Ofs, RecSize);
    GetRec := Item;
  end;

function TRLCollection.FirstThatRec(Test : pointer) : pointer;
  begin
    FirstThatRec := GetRec(FirstThat(Test));
  end;


{*** TFourByteCollection ***}

constructor TFourByteCollection.Load(var S: TStream);
  var C, I: Integer;
  begin
    S.Read(Count, SizeOf(Integer) * 3);
    Items := nil;
    C := Count; I := Limit;
    Count := 0; Limit := 0;
    SetLimit(I); Count := C;
    S.Read(Items^, C*sizeof(pointer));
  end;

procedure TFourByteCollection.Store(var S: TStream);
  var C, I: Integer;
  begin
    S.Write(Count, SizeOf(Integer) * 3);
    S.Write(Items^, Count*sizeof(pointer));
  end;

procedure TFourByteCollection.FreeItem(Item: pointer);
  begin
  end;

procedure TFourByteCollection.Pack;
  begin
    SetLimit(Count);
  end;

destructor TFourByteCollection.Done;
  begin
    DeleteAll; SetLimit(0);
  end;


{*** TSortedNumCollection ***}

constructor TSortedNumCollection.Load(var S: TStream);
  var C, I: Integer;
  begin
    S.Read(Count, SizeOf(Integer) * 3);
    Items := nil;
    C := Count; I := Limit;
    Count := 0; Limit := 0;
    SetLimit(I); Count := C;
    S.Read(Items^, C*sizeof(pointer));
  end;

procedure TSortedNumCollection.Store(var S: TStream);
  var C, I: Integer;
  begin
    S.Write(Count, SizeOf(Integer) * 3);
    S.Write(Items^, Count*sizeof(pointer));
  end;

procedure TSortedNumCollection.FreeItem(Item: pointer);
  begin
  end;

procedure TSortedNumCollection.Pack;
  begin
    SetLimit(Count);
  end;

function TSortedNumCollection.Compare(Key1, Key2: Pointer): Integer; assembler;
  asm
    db    $66
    mov   ax, word ptr Key1
    db    $66
    sub   ax, word ptr Key2
    jz    @@E
    mov   ax, 1
    jns   @@E
    mov   ax, -1
@@E:
  end;

destructor TSortedNumCollection.Done;
  begin
    DeleteAll; SetLimit(0);
  end;


{*** TTextFile ***}

constructor TTextFile.Init(S : PStream);
  begin
    inherited Init;
    Stream := S;
    if (S = nil) or (S^.Status <> stOk) or (S^.GetSize = 0) then
      begin
        Done; fail;
      end;
  end;

destructor TTextFile.Done;
  begin
    if Stream <> nil then dispose(Stream, Done);
    inherited Done;
  end;

procedure TTextFile.ReadLine(var S : string);
  var C : char;
      I : integer;
  begin
    i := 0;
    fillchar(S[1], 255, ' ');
    repeat
      inc(i);
      Stream^.Read(C, 1);
      if Stream^.Status <> stOk then break;
      case C of
        ^I : inc(i, 9-(i and $07));
        ^M : dec(i);
        ^Z,^J : break;
      else if i <= 255 then S[i] := C else break;
      end
    until false;
    dec(i);
    if i > 255 then S[0] := #255
    else S[0] := chr(i);
  end;

procedure TTextFile.WriteLine(S : string);
  begin
    S := S + ^J^M;
    Stream^.Write(S[1], ord(S[0]));
  end;

function TTextFile.ReadStr : PString;
  var S : string;
  begin
    ReadLine(S);
    ReadStr := NewStr(S);
  end;

procedure TTextFile.Reset;
  begin
    Stream^.Flush;
    Stream^.Seek(0);
  end;


{*** TBuffer ***}

procedure TBuffer.Init(P : pointer; Size : word);
  begin
    Bag := P;
    BufSize := Size;
    Position := 0;
    DataSize := 0;
  end;

procedure TBuffer.Create(Size : word);
  begin
    if Size <> BufSize then
      begin
        Free;
        getmem(Bag, Size);
        BufSize := Size;
      end;
    Position := 0;
    DataSize := 0;
  end;

procedure TBuffer.Reset;
  begin
    Position := 0;
    DataSize := 0;
  end;

function TBuffer.Seek(P : word) : boolean;
  begin
    if BufSize < P then Seek := false
    else
      begin
        Position := P;
        Seek := true;
      end;
  end;

function TBuffer.ReadAt(var Buf; Size,Pos : word) : boolean;
  begin
    if Size + Pos >= BufSize then ReadAt := false
    else
      begin
        move(ptr(ptrrec(Bag).Seg, ptrrec(Bag).Ofs+Pos)^, Buf, Size);
        ReadAt := true;
      end;
  end;

function TBuffer.WriteAt(var Buf; Size,Pos : word) : boolean;
  begin
    if Size + Pos > BufSize then WriteAt := false
    else
      begin
        move(Buf, ptr(ptrrec(Bag).Seg, ptrrec(Bag).Ofs+Pos)^, Size);
        DataSize := Maxword(DataSize, Pos+Size);
        WriteAt := true;
      end;
  end;

function TBuffer.Read(var Buf; Size : word) : boolean;
  begin
    if Size + Position > BufSize then Read := false
    else
      begin
        move(ptr(ptrrec(Bag).Seg, ptrrec(Bag).Ofs+Position)^, Buf, Size);
        inc(Position, Size);
        Read := true;
      end;
  end;

function TBuffer.Write(var Buf; Size : word) : boolean;
  begin
    if Size + Position > BufSize then Write := false
    else
      begin
        move(Buf, ptr(ptrrec(Bag).Seg, ptrrec(Bag).Ofs+Position)^, Size);
        inc(Position, Size);
        DataSize := Maxword(DataSize, Position);
        Write := true;
      end;
  end;

function TBuffer.GetPtr : pointer;
  begin
    GetPtr := ptr(ptrrec(Bag).Seg, ptrrec(Bag).Ofs+Position);
  end;

function TBuffer.PutBit(Number : word; Value : boolean) : boolean; assembler;
  asm
        les   di, Self
        mov   bx, Number
        mov   cx, bx
        shr   bx, 3
        add   bx, es:[di].Self.Position
        mov   al, 1
        cmp   bx, es:[di].Self.BufSize
        jb    @@E
        dec   al
        les   di, es:[di].Self.Bag
        and   cl, 7
        mov   dl, 1
        shl   dl, cl
        mov   cl, Value
        cmp   cl, 0
        je    @@1
        or    es:[bx+di], dl
        jmp   @@E
@@1:    not   dl
        and   es:[bx+di], dl
@@E:
  end;


function TBuffer.GetBit(Number : word; var Value : boolean) : boolean; assembler;
  asm
        les   di, Self
        mov   bx, Number
        mov   cx, bx
        shr   bx, 3
        add   bx, es:[di].Self.Position
        mov   al, 1
        cmp   bx, es:[di].Self.BufSize
        jb    @@E
        dec   al
        jb    @@E
        les   di, es:[di].Self.Bag
        mov   bl, es:[bx+di]
        and   cl, 7
        shr   bl, cl
        and   bl, 1
        les   di, Value
        mov   es:[di],  bl
@@E:
  end;

procedure TBuffer.Free;
  begin
    if BufSize <> 0 then
      begin
        freemem(Bag, BufSize);
        BufSize := 0;
      end;
  end;


function ScanAt(P : PCollection; At : integer; Action : pointer) : integer; assembler;
  asm
        mov   ax, -1
        les   di, P
        mov   cx, es:[di].TCollection.Count
        jcxz  @@Q
        mov   bx, At
        sub   cx, bx
        jle   @@Q
        les   di, es:[di].TCollection.Items
        shl   bx, 2
        add   di, bx
@@2:    mov   word ptr P+2, es
        mov   word ptr P, di
        push  cx
        db    66h;  push  word ptr es:[di]
        push  word ptr [bp]
        call  Action
        pop   cx
        or    al, al
        jnz   @@1
        les   di, P
        add   di, 4
        inc   At
        loop  @@2
        mov   At, -1
@@1:    mov   ax, At
@@Q:
  end;


const
  RLineCollection : TStreamRec = (
    ObjType : 81;
    VmtLink : Ofs(TypeOf(TLineCollection)^);
    Load    : @TLineCollection.Load;
    Store   : @TLineCollection.Store);

  RRecordCollection : TStreamRec = (
    ObjType : 82;
    VmtLink : Ofs(TypeOf(TRecordCollection)^);
    Load    : @TRecordCollection.Load;
    Store   : @TRecordCollection.Store);

  RRSCollection : TStreamRec = (
    ObjType : 83;
    VmtLink : Ofs(TypeOf(TRSCollection)^);
    Load    : @TRSCollection.Load;
    Store   : @TRSCollection.Store);

  RRLCollection : TStreamRec = (
    ObjType : 84;
    VmtLink : Ofs(TypeOf(TRLCollection)^);
    Load    : @TRLCollection.Load;
    Store   : @TRLCollection.Store);

procedure RegisterObjUtils;
  begin
    RegisterType(RLineCollection);
    RegisterType(RRecordCollection);
    RegisterType(RRSCollection);
    RegisterType(RRLCollection);
  end;

end.
