unit ReadIni;
(*    ⥭ ࠬ஢ 樠樨  ⥪⮢ 䠩  ଠ,
   WIN.INI  CONFIG.SYS.

  ப  ࠬࠬ 㯯஢  ᥪ樨.
   ப   祢 ᫮, ⥬   ᪮쪮 祭.
  ⥫ - ࠢ, , ஡   ᨬ    ஡.
   ---ப 窠  ⮩.
   ਨ  ᪠᪮ ⨯ -  䨣묨 ᪮,
  ᪠ .
   ᥪ樨 砥   ᪮.

   אַ   砫 ᥪ樨, ᫥⥫  אַ 
   ப  ᥪ樨  祢 ᫮.

  祢 ᫮ INCLUDE  ᫥騬  ᥪ樨 樨 室
   㪠 ᥪ   ணࠬ.

   ᪥ ᥪ樨    ᥪ樨 (祢 ᫮) 室 
   孥 ॣ, ᨬ  ⮣,  ᠭ 䠩.

*)

interface

uses Objects, Memory, Dos, History, ObjUtil, AdvUtil, InLines;

{ $DEFINE INCLUDE} { ।, ᫨ ॡ 砥 䠩 }

const
  BufferLimit   : word = 2048;
  IncludeLimit  : byte = 10;
  TabStep       : byte = 8;
  {$IFDEF INCLUDE}
  IncludePath   : FNameStr = '';
  {$ENDIF}
  EndIniFile    : boolean = false;
  EndLine       : boolean = false;
  AllReaded : boolean = false;
  IniError  : integer = 0;
  NextChar  : char = #0;
  NameDelimit   = '''';
  BoolEnglish : boolean = true;
  BoolForm : array[false..true] of string[8] = (' ', 'NO YES');

  MaxLineLength = 150;

  efOutOfMemory     = 1;
  efNoIncludeName   = 2;
  efIncludeNotFound = 3;
  efTooManyIncludes = 4;
  efLineLong        = 5;
  efNoString        = 6;
  efUnknownID       = 7;
  efNoNumeric       = 8;
  efOutOfRange      = 9;
  efFileError       = 100;

function OpenIniFile(const InFile : FNameStr) : boolean;
  {$IFDEF DPMI} export; {$ENDIF}
procedure CloseIniFile;
  {$IFDEF DPMI} export; {$ENDIF}
function GetIniError : integer;
  {$IFDEF DPMI} export; {$ENDIF}
  { 頥 訡  뢠 . }

{$IFDEF INCLUDE}
procedure SetIncludePath(const P : FNameStr);
  {$IFDEF DPMI} export; {$ENDIF}
{$ENDIF}

function SearchSection(const SecName : string) : boolean;
  {$IFDEF DPMI} export; {$ENDIF}
  {  ᥪ樨  ⥪饩 樨.
    樨   ᥪ権  אַ 㯠
    ᫥ 饭.
     ⠭  ᫥ ப ᫥  ᥪ樨.
    㤠筮 ᪥ 頥 false }

function GetSection(var SecName : string) : boolean;
  {$IFDEF DPMI} export; {$ENDIF}
  { 室  ᫥饩 ᥪ樨. (᫥⥫ )
     ⠭  ᫥ ப ᫥  ᥪ樨.
    㤠筮 ᪥ 頥 false }

procedure InitGetSection;
  {$IFDEF DPMI} export; {$ENDIF}
  {  稪 ᥪ権 - ⮡  ᭠砫 横  GetSection }

function SearchKey(const Key : string) : boolean;
  {$IFDEF DPMI} export; {$ENDIF}
  {  ப   祢 ᫮  砫 ᥪ樨 (אַ ).
      ⠭  ᫥騩 ᨬ ᫥ .
     㤠筮 ᪥ 頥 false }

function GetKey(var Key : string) : boolean;
  {$IFDEF DPMI} export; {$ENDIF}
  { 祭 ᫥饣 祢 ᫮ (᫥⥫ ).
    砭 ᥪ樨 頥 false }

function GetInteger(Min, Max, Default : longint) : longint;
  {$IFDEF DPMI} export; {$ENDIF}
  { 祭 楫᫥ 祭  ⥪饩 樨
     ய᪮ । ࠧ⥫. }

function GetFloat(Min, Max, Default : extended) : extended;
  {$IFDEF DPMI} export; {$ENDIF}
  { 祭 祭  饩 窮  ⥪饩 樨
     ய᪮ । ࠧ⥫. }

function GetStatementNumber(const S : string; Default : integer) : integer;
  {$IFDEF DPMI} export; {$ENDIF}
  { ⥭ ᫮  ⥪饩 樨  ய᪮ । ࠧ⥫
    祭  ⠭ ᫮  ப S. }

function GetString(const Default : string) : string;
  {$IFDEF DPMI} export; {$ENDIF}
  { 祭 ப 祭  ࠧ⥫
    ⥪饩 樨  ய᪮ । ࠧ⥫. }

function GetQuoteString(const Default : string) : string;
  {$IFDEF DPMI} export; {$ENDIF}
  { 祭 ப 祭  窠
    ⥪饩 樨  ய᪮ । ࠧ⥫. }

function GetBoolean(Default : boolean) : boolean;
  {$IFDEF DPMI} export; {$ENDIF}
  { 祭 㫥᪮ 祭  ⥪饩 樨
     ய᪮ । ࠧ⥫. }

function GetLine : string;
  {$IFDEF DPMI} export; {$ENDIF}
  { 祭  ⥪饩 ப.   ⠥ . }

(* ஢ 楤 *)
procedure Blanks;
  {$IFDEF DPMI} export; {$ENDIF}
  { ய ࠧ⥫  ஥ ࠡ⪠ ਥ. }
  { ⥫ﬨ  ᨬ '=', ',', ' ',  ப    
    ஡ }

function ReadWord : string;
  {$IFDEF DPMI} export; {$ENDIF}
  { ⥭ ᫮  ⥪饩 樨  ய᪮ । ࠧ⥫. }

function ReadString(LD, RD : char) : string;
  {$IFDEF DPMI} export; {$ENDIF}
  { ⥭ ப  ᨬ   ࠢ ࠭. }

function ReadChar : char;
  {$IFDEF DPMI} export; {$ENDIF}
  { ⥭ ᨬ. }

function ReadNumeric : string;
  {$IFDEF DPMI} export; {$ENDIF}
  { ⥭ ᫮, 饣 ᫮. }

function ReadStr : string;
  {$IFDEF DPMI} export; {$ENDIF}
  { ⥭ ப  ⥪饩 樨. }

function CheckStatement(const S,D : string) : byte;
  {$IFDEF DPMI} export; {$ENDIF}
  {  ᫮ S  ப D,  ᫥ ᫮ १ ஡.
    頥 0, ᫨  襫,  -  ᫮ ( 1). }

function GetStatement(const D : string; I : byte) : string;
  {$IFDEF DPMI} export; {$ENDIF}
  { 頥 ᫮  I  ப D ( 1).
     砥 㤠 -  ப. }

function ReadWordDelim(const Delims : TCharset) : string;
  {$IFDEF DPMI} export; {$ENDIF}
  { ⥭ ᫮  ⥪饩 樨  ய᪮ । ࠧ⥫
     ࠧ⥫  Delims. }

function ReadPhrase : string;
  {$IFDEF DPMI} export; {$ENDIF}
  { ⥭ ப  ⥪饩 樨  ய᪮ । ࠧ⥫
        ப  १  ஡. }


implementation

type
  PInputFile = ^TInputFile;
  TInputFile = object
    FName  : PString;
    Stream : TDosStream;
    Buffer : pointer;
    BufSize: word;
    BufPos : word;
    BufEnd : word;
    Line      : integer;
    Position  : integer;
    ReadPos   : longint;
    LinePos   : longint;
    function Init(F : PString) : boolean;
    procedure Done;
    procedure Seek(NewPos : longint; NewLine : word);
  end;

  PSection = ^TSection;
  TSection = record
    FilePos : longint;
    LineNum : word;
{$IFDEF INCLUDE}
    FileRec : PInputFile;
{$ENDIF}
  end;

  PSectionRec = ^TSectionRec;
  TSectionRec = record
    Descript: TSection;
    Name    : string;
  end;

  PInputSection = ^TInputSection;
  TInputSection = record
    CurPos  : longint;
    CurLine : word;
    Section : PSectionRec;
  end;

  PFileList = ^TFileList;
  TFileList = object(TStringCollection)
    procedure FreeItem(Item : pointer); virtual;
    function KeyOf(Item : pointer) : pointer; virtual;
  end;

var
  Input     : TInputFile;
{$IFDEF INCLUDE}
  FileStack : TStackMemory;
  FileList  : TFileList;
{$ENDIF}
  SectionStack: TStackMemory;
  SectionList : TRSCollection;
  LastSect    : TSection;

  ErrorParam : record
    FileName : PString;
    case integer of
    0 : (LineNum : longint;
         LineCode : longint;
         LineDesc : PString;
         StrValue : PString);
    1 : (Code : longint;
         Desc : PString;
         Idle : longint;
         Value: longint);
  end;

const
  Letters   : set of Char=
              ['0'..'9','A'..'Z','a'..'z',''..'',''..'',''..'','_','@','$'];
  Numeric   : set of Char=
              ['0'..'9','a'..'f','A'..'F','.','+','-','E','e','$'];
{$IFDEF INCLUDE}
  CurrentInclude : PString = nil;
  CurrentFile    : PInputFile = nil;
{$ENDIF}
  CurrentSection : PSectionRec = nil;
  MainSection    : PSectionRec = nil;
  InternalCall   : boolean = false;
  SectionCount   : integer = 0;

procedure Error(Code : integer);
  begin
    IniError := Code;
  end;

function GetIniError : integer;
  begin
    GetIniError := IniError;
    IniError := 0;
  end;

{$IFDEF INCLUDE}

procedure SetIncludePath(const P : FNameStr);
  begin
    IncludePath := P;
  end;

procedure ReadIncludeName;
  var DirInfo : SearchRec;
      F : FNameStr;
      E : ExtStr;
  begin
    F := ReadWord;
    if F = '' then
      begin
        Error(efNoIncludeName);
        exit;
      end;
    repeat
      case NextChar of
        '.' : begin
                ReadChar;
                E := ReadWord;
                break;
              end;
        ':','\' : F := F + ReadChar + ReadWord;
      else begin
              E := 'ini';
              break;
            end;
      end;
    until false;
    CurrentInclude := NewStr(F+'.'+E);
    FindFirst(CurrentInclude^, AnyFile, DirInfo);
    if DosError <> 0 then
      begin
        Error(efIncludeNotFound);
        CurrentInclude := nil;
      end;
  end;

procedure LoadInclude;
  begin
    if CurrentInclude <> nil then
    if FileStack.Push(CurrentFile) then
      begin
        Input.Init(CurrentInclude);
        new(CurrentFile);
        CurrentFile^ := Input;
        FileList.Insert(CurrentFile);
      end
    else Error(efTooManyIncludes);
  end;

procedure DoneInclude;
  begin
    FileStack.Pop(CurrentFile);
    Input := CurrentFile^;
    ErrorParam.FileName := Input.FName;
    EndIniFile := false;
  end;
{$ENDIF}

procedure DoRead;
  var Sz : longint;
  begin
    with Input do
      begin
        ReadPos := Stream.GetPos;
  {$IFDEF INCLUDE}
        repeat
  {$ENDIF}
          Sz := Stream.GetSize;
          if ReadPos = Sz then EndIniFile := true
          else
            if (Sz-ReadPos) < BufSize then
              BufEnd := Sz-ReadPos
            else BufEnd := BufSize;
  {$IFDEF INCLUDE}
          if EndIniFile and (FileStack.Count <> 0) then
            begin
              DoneInclude;
              if BufPos < BufEnd then exit
            end
          else break;
          ReadPos := Stream.GetPos;
        until false;
  {$ENDIF}
        if EndIniFile then AllReaded := true
        else
          begin
            Stream.Read(Buffer^, BufEnd);
            BufPos := 0;
          end;
      end;
  end;


procedure TFileList.FreeItem(Item : pointer);
  begin
    PInputFile(Item)^.Done;
    freemem(Item, sizeof(TInputFile));
  end;

function TFileList.KeyOf(Item : pointer) : pointer;
  begin
    KeyOf := PInputFile(Item)^.FName;
  end;

procedure SeekToSection(var S : TSection);
  begin
{$IFDEF INCLUDE}
    if S.FileRec <> CurrentFile then
      begin
        FileStack.Reset;
        CurrentFile := S.FileRec;
        Input := CurrentFile^;
        FileStack.Push(CurrentFile);
      end;
{$ENDIF}
    Input.Seek(S.FilePos, S.LineNum);
  end;

function ReadSection(var I : integer) : string;
  var S : string;
  begin
    ReadSection := '';
    repeat
      S := '';
      repeat
        Blanks;
        if NextChar <> '[' then ReadStr
        else S := UpCaseStr(ReadString('[', ']'));
        if (IniError <> 0) or EndIniFile then exit;
      until S <> '';
      ReadStr;
      if not SectionList.Search(@S, I) then
        begin
          LastSect.FilePos := Input.ReadPos + Input.BufPos;
          LastSect.LineNum := Input.Line;
{$IFDEF INCLUDE}
          LastSect.FileRec := CurrentFile;
{$ENDIF}
          SectionList.AtInsertRec(LastSect, S, i);
          break;
        end;
    until false;
    ReadSection := S;
  end;

function SearchSection(const SecName : string) : boolean;
  var S : string;
      I : integer;
  begin
    SearchSection := false;
    IniError := 0;
    if (CurrentSection = nil) or (CurrentSection^.Name <> SecName) then
    if SectionList.Search(@SecName, I) then
      CurrentSection := PSectionRec(SectionList.AtRec(i))
    else
      begin
        if AllReaded then exit;
        repeat
          S := ReadSection(i);
          if S = '' then exit;
        until S = secName;
        CurrentSection := SectionList.AtRec(i);
      end;
    SeekToSection(CurrentSection^.Descript);
    if not InternalCall then MainSection := CurrentSection;
    SearchSection := true;
  end;

function GetKey(var Key : string) : boolean;
  var Inp : TInputSection;
      S : string;
  begin
    IniError := 0;
    GetKey := false;
    repeat
      if Input.ReadPos + Input.BufPos <> Input.LinePos then ReadStr;
      Blanks;
      if IniError <> 0 then exit;
      if EndIniFile or (NextChar = '[') then
        begin
          if not SectionStack.Pop(Inp) then exit;
{$IFDEF INCLUDE}
          with Inp.Section^.Descript do
          if FileRec <> CurrentFile then
            begin
              CurrentFile := FileRec;
              Input := CurrentFile^;
              FileStack.Push(CurrentFile);
            end;
{$ENDIF}
          Input.Seek(Inp.CurPos, Inp.CurLine);
          continue;
        end;
      Key := UpCaseStr(ReadWord);
      if IniError <> 0 then exit;
      if Key <> 'INCLUDE' then
        begin
          GetKey := true; break;
        end;
      Blanks; S := UpcaseStr(ReadWord);
      if IniError <> 0 then exit;
      Inp.CurPos := Input.ReadPos + Input.BufPos;
      Inp.CurLine := Input.Line;
      Inp.Section := CurrentSection;
      InternalCall := true;
      if SearchSection(S) then SectionStack.Push(Inp)
      else SearchSection(Inp.Section^.Name);
      InternalCall := false;
    until false;
  end;

function SearchKey(const Key : string) : boolean;
  var FindKey : string;
  begin
    SearchKey := false;
    if MainSection = nil then exit;
    CurrentSection := MainSection;
    SectionStack.Reset;
    SeekToSection(CurrentSection^.Descript);
    while GetKey(FindKey) do
      if FindKey = Key then
        begin
          SearchKey := true;
          break;
        end;
  end;

procedure InitGetSection;
  begin
    SectionCount := 0;
  end;

function GetSection(var SecName : string) : boolean;
  var I : integer;
  begin
    GetSection := false;
    IniError := 0;
    if SectionCount < SectionList.Count then
      begin
        CurrentSection := PSectionRec(SectionList.AtRec(SectionCount));
        SecName := CurrentSection^.Name;
      end
    else
      begin
        if AllReaded then exit;
        SeekToSection(LastSect);
        SecName := ReadSection(i);
        if SecName = '' then exit;
        CurrentSection := SectionList.AtRec(i);
        inc(SectionCount);
      end;
    SeekToSection(CurrentSection^.Descript);
    if not InternalCall then MainSection := CurrentSection;
    GetSection := true;
    inc(SectionCount);
  end;

function TInputFile.Init(F : pstring) : boolean;
  var StreamSize : longint;
  begin
    FName := F;
    ErrorParam.FileName := FName;
    Stream.Init(F^, stOpenRead);
    if Stream.Status <> stOk then
      begin
        Init := false;
        exit;
      end;
    BufSize := BufferLimit;
    StreamSize := Stream.GetSize;
    if BufSize > StreamSize then BufSize := StreamSize;
    if (BufSize >= MaxAvail) or (StreamSize shr 1 > MemAvail) then
      begin
        Error(efOutOfMemory);
        Buffer := nil;
        Init := false;
        exit;
      end;
    Buffer := MemAllocSeg(BufSize);
    BufPos := 0;
    BufEnd := 0;
    Line := 1;
    Position := 0;
    LinePos := 0;
    ReadPos := 0;
    Init := true;
  end;

procedure TInputFile.Done;
  begin
    DisposeStr(FName);
    if Buffer <> nil then FreeMem(Buffer, BufSize);
    Stream.Done;
  end;

procedure TInputFile.Seek(NewPos : longint; NewLine : word);
  begin
    EndIniFile := false;
    if (NewPos > ReadPos + BufPos) or (NewPos < ReadPos) then
      begin
        Stream.Seek(NewPos);
        DoRead;
      end
    else BufPos := NewPos - ReadPos;
    LinePos := NewPos;
    Line := NewLine;
  end;

var SaveStreamError : pointer;

procedure ErrorStream(var S : TStream); far;
  begin
    Error(efFileError-S.Status);
  end;

function OpenIniFile(const InFile : FNameStr) : boolean;
  begin
    SaveStreamError := StreamError;
    StreamError := @ErrorStream;
    OpenIniFile := Input.Init(newstr(InFile));
  {$IFDEF INCLUDE}
    FileStack.Init(sizeof(pointer), IncludeLimit);
    FileList.Init(16, 8);
    new(CurrentFile); CurrentFile^ := Input;
    FileList.Insert(CurrentFile);
  {$ENDIF}
    SectionList.Init(16, 8, sizeof(TSection));
    SectionStack.Init(sizeof(TInputSection), IncludeLimit);
    EndIniFile := false;
    AllReaded := false;
    SectionCount := 0;
  end;

procedure CloseIniFile;
  begin
    IniError := 0;
    SectionStack.Done;
    SectionList.Done;
  {$IFDEF INCLUDE}
    FileList.Done;
    FileStack.Done;
  {$ELSE}
    Input.Done;
  {$ENDIF}
    StreamError := SaveStreamError;
  {$IFDEF INCLUDE}
    CurrentInclude := nil;
    CurrentFile    := nil;
  {$ENDIF}
    CurrentSection := nil;
    MainSection    := nil;
    InternalCall   := false;
    SectionCount   := 0;
  end;

procedure Blanks;
var Posit : Integer;
    Comment : integer;
    EoLCFlag : byte;
  {$IFDEF INCLUDE}
    IncludeFlag : byte;
  {$ENDIF}
  begin
asm
    xor bx, bx
    mov ax, Input.Position
    mov EndLine,  bl
    mov Posit, ax
  {$IFDEF INCLUDE}
    mov   IncludeFlag, bl
  {$ENDIF}
    mov   EoLCFlag, bl
    mov   Comment,  bx
@S: mov si, Input.BufPos
    mov dx, Input.BufEnd
    mov es, Input.Buffer.Word[2]
    cld
    xor ah, ah

@next:
    cmp si, dx
    jne @6
    add   Input.Line, bx
    call DoRead
    xor   bx, bx
    cmp   EndIniFile, true
    je    @quit
    jmp @S
@6: seges lodsb
    cmp al, 0Dh
    jne @1
    cmp ah, 0Ah
    je  @ResetCRLF       {LF,CR}
@4: inc bx
    mov   EoLCFlag, 0
    mov Posit, 0
    mov ah, al
@SetLinePos:
    mov   cx, Input.ReadPos.word
    add   cx, si
    mov   Input.LinePos.word, cx
    mov   cx, Input.ReadPos.word[2]
    adc   cx, 0
    mov   Input.LinePos.word[2], cx
    jmp @next
@1: cmp al, 0Ah
    jne @cont
    cmp ah, 0Dh
    jne @4       {CR,LF}
@ResetCRLF:
    xor   ax, ax
    mov   EndLine, true
    jmp   @SetLinePos
@Cont:
    inc Posit

@CheckOpenComment:
    cmp   al, '{'
    jne   @CheckCloseComment
  {$IFDEF INCLUDE}
    cmp   Comment,0
    jne   @NextInc
    inc   IncludeFlag
@NextInc:
  {$ENDIF}
    inc   Comment
    jmp   @next

@CheckCloseComment:
    cmp   al, '}'
    jne   @CheckComment
    dec   Comment
  {$IFDEF INCLUDE}
    cmp   IncludeFlag,2
    jne   @next
    cmp   Comment,0
    jne   @next
    mov   IncludeFlag,0
    mov   Input.BufPos, si
    add   Input.Line, bx
    mov   bx, Posit
    mov   Input.Position, bx
    call  LoadInclude
    mov   bx, Input.Position
    mov   Posit, bx
    xor   bx, bx
    jmp   @S
  {$ELSE}
    jmp   @next
  {$ENDIF}

@CheckComment:
    cmp   Comment,0
    je    @CheckEoLComment
  {$IFDEF INCLUDE}
    cmp   IncludeFlag,1
    jne   @next
    cmp   al, '$'
    jne   @ResetInclude
    inc   IncludeFlag
    mov   Input.BufPos, si
    add   Input.Line, bx
    mov   bx, Posit
    mov   Input.Position, bx
    call  ReadIncludeName
    xor   bx, bx
    mov   ax, Input.Position
    mov   Posit, ax
    jmp   @S
@ResetInclude:
    dec   IncludeFlag
  {$ENDIF}
    jmp   @next

@CheckEoLComment:
    cmp   EoLCFlag, 0
    jne   @next
    cmp   al, ';'
    jne   @CheckControls
    inc   EoLCFlag
    jmp   @next

@CheckControls:
    cmp al, ' '
    ja  @CheckDivider

@CheckTab:
    cmp al, 9h
    jne @next
    mov ax, Posit
    mov cl, TabStep
    div cl
    inc al
    mul cl
    mov Posit, ax
    jmp @next

@CheckDivider:
    cmp   al, '='
    je    @next
    cmp   al, ','
    je    @next

@exit:
    mov NextChar, al
    dec si
    mov Input.BufPos, si
    add Input.Line, bx
    mov bx, Posit
    dec bx
    mov Input.Position, bx
@quit:
end;
end;

function ReadChars(TableOffset : word) : string;
  begin
    ReadChars := '';
    Blanks;
    if EndIniFile or (IniError <> 0) then exit;
    asm
@Start: les   di, @Result
        inc   di
        mov   si, Input.BufPos
        mov   dx, Input.BufEnd
        push  ds
        mov   ds, Input.Buffer.Word[2]
        cld

@Next:  cmp   si, dx
        jne   @Cont
        pop   ds
        call  DoRead
        xor   si, si
        cmp   EndIniFile,  true
        je    @Exit
        jmp   @Start

@Cont:  lodsb
        mov   cl, al
        mov   bl, al
        pop   ds
        and   cl, 7
        xor   bh, bh
        shr   bl, 3
        mov   ah, 1
        shl   ah, cl
        add   bx, TableOffset
        test  byte ptr ds:[bx], ah
        jz    @Exit
        mov   bx, word ptr @Result
        cmp   byte ptr es:[bx], 255
        je    @Long
        inc   byte ptr es:[bx]
        inc   Input.Position
        push  ds
        mov   ds, Input.Buffer.Word[2]
        stosb
        jmp   @Next

@Long:
        push  si
        push  efLineLong
        call  near ptr Error
        pop   si
@Exit:
        mov   NextChar, ch
        dec   si
        mov   Input.BufPos, si
    end;
  end;

function ReadWord : string;
  begin
    ReadWord := ReadChars(ofs(Letters));
  end;

function ReadNumeric : string;
  begin
    ReadNumeric := ReadChars(ofs(Numeric));
  end;

function ReadWordDelim(const Delims : TCharset) : string;
  const ValidChars : set of char = [];
  begin
    asm
      {ValidChars := [#0..#255] - Delims;}
      les   di, Delims
      lea   si, ValidChars
      mov   cx, $10
  @@1:mov   ax, es:[di]
      add   di, 2
      not   ax
      mov   [si], ax
      add   si, 2
      loop  @@1
    {exclude(ValidChars, #$0D);}
    {exclude(ValidChars, #$0A);}
      and   word ptr ValidChars, not $2400
    {exclude(ValidChars, '{');}
    {exclude(ValidChars, ';');}
      and   byte ptr ValidChars+$F, not $8
      and   byte ptr ValidChars+$7, not $8
    end;
    ReadWordDelim := ReadChars(ofs(ValidChars));
  end;

function ReadPhrase : string;
  var S : string;
      p : byte;
  begin
    Blanks;
    S := ReadStr;
    p := charpos(';', s);
    if p <> 0 then S[0] := chr(pred(p));
    while (length(S) <> 0) and (S[length(S)] = ' ') do dec(byte(s[0]));
    ReadPhrase := S;
  end;

function ReadString(LD, RD : Char) : string;
  begin
       ReadString := '';
       Blanks;
       if EndIniFile or (IniError <> 0) then exit;
asm
        mov dx, Input.BufPos
        cmp dx, Input.BufEnd
        jne @4
        call DoRead
        cmp  EndIniFile,   true
        je   @Q
@4:     mov es, Input.Buffer.Word[2]
        mov di, Input.BufPos
        mov al, byte ptr es:[di]
        inc Input.BufPos
        inc Input.Position
        cmp al, LD
        les di, @Result
        mov al, 0
        cld
        stosb
        jne @Q
@6:     push ds
        mov si, Input.BufPos
        mov dx, Input.BufEnd
        mov ds, Input.Buffer.Word[2]
        cld
@3:     cmp dx, si
        jne @5
        pop ds
        push es
        push di
        call DoRead
        pop di
        pop es
        cmp   EndIniFile,  true
        je    @7
        cmp   IniError, 0
        jne   @7
        jmp @6
@5:     lodsb
        cmp al, RD
        je @2
        stosb
        jmp @3
@2:     pop ds
@7:     mov Input.BufPos, si
        mov ax, di
        mov di, word ptr @Result
        sub ax, di
        dec ax
        cmp ax, 255
        jle @9
        push efLineLong
        call near ptr Error
@9:     stosb
        inc ax
        add Input.Position, ax
        jmp @Q
@1:     pop ds
@Q:
end;
end;

function ReadChar : char; assembler;
  asm
{$IFDEF DPMI}
      push  ds
      mov   ax, SEG @DATA
      mov   ds, ax
{$ENDIF}
      mov   bx, Input.BufPos
      cmp   bx, Input.BufEnd
      jne   @1
      call  DoRead
      cmp   EndIniFile,   true
      je    @Q
      cmp   IniError, 0
      jne   @Q
@1:   mov   es, Input.Buffer.word[2]
      mov   di, Input.BufPos
      mov   al, es:[di]
      inc   Input.BufPos
      inc   Input.Position
@Q:
{$IFDEF DPMI}
      pop   ds
{$ENDIF}
  end;

function ReadStr : string;
  var Line : word;
  begin
    ReadStr := '';
    if EndIniFile or (IniError <> 0) then exit;
    asm
        mov   Line,  0
        mov   si, Input.BufPos
        cmp   si, Input.BufEnd
        jne   @Begin
@ReadBuf:
        call  DoRead
        mov   si, Input.BufPos
        cmp   EndIniFile, True
        je    @E
@Begin: les   di, @Result
        cld
        mov   bx, di
        xor   ah, ah
        mov   al, es:[bx]
        add   di, ax
        inc   di

        mov   cx, Input.BufEnd
        sub   cx, si
        push  ds
        mov   ds, Input.Buffer.Word[2]

@Next:  lodsb
        cmp   al,  0Dh
        je    @EoL1
        cmp   al,  0Ah
        je    @EoL2
        stosb
        inc   es:[bx].byte
        cmp   es:[bx].byte, MaxLineLength
        ja    @Long
@Cont:  loop  @Next

        pop   ds
        mov   Input.BufPos, si
        jmp   @ReadBuf

@EoL1:  cmp   Line, 0
        jne   @EoL2
        inc   Line
        mov   EndLine, true
        jmp   @Cont

@Long:
        pop   ds
        mov   al, es:[bx]
        xor   ah,ah
        add   Input.Position, ax
        push  si
        push  efLineLong
        call  near ptr Error
        pop   si
        jmp   @E

@EoL2:
        pop   ds
        mov   Input.Position, 0
        inc   Input.Line
  @E:
        mov   Input.BufPos, si
        mov   cx, Input.ReadPos.word
        add   cx, Input.BufPos
        mov   Input.LinePos.word, cx
        mov   cx, Input.ReadPos.word[2]
        adc   cx, 0
        mov   Input.LinePos.word[2], cx
  @Q:
    end;
  end;

function GetLine : string;
  var SaveBufPos : word;
      SaveReadPos : longint;
  begin
    with Input do
      begin
        SaveBufPos := BufPos;
        SaveReadPos := ReadPos;
        if LinePos >= ReadPos then BufPos := LinePos - ReadPos
        else
          begin
            Stream.Seek(LinePos);
            DoRead;
          end;
        GetLine := ReadStr;
        BufPos := SaveReadPos + SaveBufPos - ReadPos;
      end;
  end;

function CheckStatement(const S,D : string) : byte; assembler;
  asm
        push    ds
        mov     bx, 1
        xor     ah, ah
        cld
        les     di, D
        mov     al, es:[di].Byte
        inc     di
        mov     dx, di
        add     dx, ax
@@search:
        lds     si, S
        lodsb
        mov     cx, ax                  { cx = size of source word}
        repe    cmpsb                   { search word in array}
        je      @@found
        mov     cx, dx
        sub     cx, di
        mov     al, ' '
        repne   scasb
        inc     bx
        cmp     di, dx                  { no more key in array ?}
        jb      @@search                { next search}
@@bad:
        xor     bx, bx
@@found:
        mov     ax, bx
        pop     ds
  end;

function GetStatement(const D : string; I : byte) : string; assembler;
  asm
        les di,D
        xor cx,cx
        mov dx,cx
        mov cl,es:[di]
        inc di
        mov dl,I
        mov al,' '
        cld
@@2:    sub dl,1
        jle @@1
        jcxz @@1
        repne scasb
        jmp @@2
@@1:    push ds
        mov ds,word ptr D+2
        mov si,di
        les di,@result
        mov bx,di
        xor ax,ax
        stosb
@@5:    jcxz @@4
        lodsb
        cmp al,' '
        je @@4
        stosb
        inc byte ptr es:[bx]
        loop @@5
@@4:    pop ds
  end;

function GetInteger(Min, Max, Default : longint) : longint;
  var V : longint;
      I : integer;
  begin
    GetInteger := Default;
    val(ReadNumeric, V, i);
    if I <> 0 then Error(efNoNumeric)
    else if (V < Min) or (V > Max) then Error(efOutOfRange)
      else GetInteger := V;
  end;

function GetFloat(Min, Max, Default : extended) : extended;
  var V : extended;
      I : Integer;
  begin
    GetFloat := Default;
    val(ReadNumeric, V, i);
    if I <> 0 then Error(efNoNumeric)
    else if (V < Min) or (V > Max) then Error(efOutOfRange)
      else GetFloat := V;
  end;

function GetStatementNumber(const S : string; Default : integer) : integer;
  var I : integer;
  begin
    i := CheckStatement(UpCaseStr(ReadWord), S);
    if i = 0 then
      begin
        Error(efUnknownId);
        GetStatementNumber := Default;
      end
    else GetStatementNumber := i - 1;
  end;

function GetQuoteString(const Default : string) : string;
  var S : string;
  begin
    S := ReadString(NameDelimit, NameDelimit);
    if S = '' then
      begin
        Error(efNoString);
        GetQuoteString := Default;
      end
    else GetQuoteString := S;
  end;

function GetString(const Default : string) : string;
  var S : string;
  begin
    S := ReadWord;
    if S = '' then
      begin
        Error(efNoString);
        GetString := Default;
      end
    else GetString := S;
  end;

function GetBoolean(Default : boolean) : boolean;
  begin
    GetBoolean := boolean(GetStatementNumber(BoolForm[BoolEnglish], ord(Default)));
  end;

end.
